diff --git a/lib/igt.cocci b/lib/igt.cocci
index 156f0cf..f23b511 100644
--- a/lib/igt.cocci
+++ b/lib/igt.cocci
@@ -73,7 +73,7 @@ expression list[n] Ep;
 @@
 @@
 -abort();
-+igt_fail(1);
++igt_fail(IGT_EXIT_FAILURE);
 
 @@
 iterator name for_each_pipe;
diff --git a/lib/igt_core.c b/lib/igt_core.c
index 8d60930..f9e92c9 100644
--- a/lib/igt_core.c
+++ b/lib/igt_core.c
@@ -993,8 +993,8 @@ static void print_backtrace(void)
 }
 #endif
 
-void __igt_fail_assert(int exitcode, const char *domain, const char *file,
-		       const int line, const char *func, const char *assertion,
+void __igt_fail_assert(const char *domain, const char *file, const int line,
+		       const char *func, const char *assertion,
 		       const char *f, ...)
 {
 	va_list args;
@@ -1020,7 +1020,7 @@ void __igt_fail_assert(int exitcode, const char *domain, const char *file,
 
 	if (run_under_gdb())
 		abort();
-	igt_fail(exitcode);
+	igt_fail(IGT_EXIT_FAILURE);
 }
 
 /**
diff --git a/lib/igt_core.h b/lib/igt_core.h
index 4e56be8..3a9e582 100644
--- a/lib/igt_core.h
+++ b/lib/igt_core.h
@@ -84,6 +84,12 @@ extern const char* __igt_test_description __attribute__((weak));
  */
 #define IGT_EXIT_INVALID 79
 
+/**
+ * IGT_EXIT_FAILURE
+ *
+ * Exit status indicating a test failure
+ */
+#define IGT_EXIT_FAILURE 99
 
 bool __igt_fixture(void);
 void __igt_fixture_complete(void);
@@ -250,8 +256,8 @@ void __igt_skip_check(const char *file, const int line,
 void igt_success(void);
 
 void igt_fail(int exitcode) __attribute__((noreturn));
-__attribute__((format(printf, 7, 8)))
-void __igt_fail_assert(int exitcode, const char *domain, const char *file,
+__attribute__((format(printf, 6, 7)))
+void __igt_fail_assert(const char *domain, const char *file,
 		       const int line, const char *func, const char *assertion,
 		       const char *format, ...)
 	__attribute__((noreturn));
@@ -267,7 +273,7 @@ void igt_exit(void) __attribute__((noreturn));
  */
 #define igt_assert(expr) \
 	do { if (!(expr)) \
-		__igt_fail_assert(99, IGT_LOG_DOMAIN, __FILE__, __LINE__, __func__, #expr , NULL); \
+		__igt_fail_assert(IGT_LOG_DOMAIN, __FILE__, __LINE__, __func__, #expr , NULL); \
 	} while (0)
 
 /**
@@ -284,7 +290,7 @@ void igt_exit(void) __attribute__((noreturn));
  */
 #define igt_assert_f(expr, f...) \
 	do { if (!(expr)) \
-		__igt_fail_assert(99, IGT_LOG_DOMAIN, __FILE__, __LINE__, __func__, #expr , f); \
+		__igt_fail_assert(IGT_LOG_DOMAIN, __FILE__, __LINE__, __func__, #expr , f); \
 	} while (0)
 
 /**
@@ -329,7 +335,7 @@ void igt_exit(void) __attribute__((noreturn));
 	do { \
 		int __n1 = (n1), __n2 = (n2); \
 		if (__n1 cmp __n2) ; else \
-		__igt_fail_assert(99, IGT_LOG_DOMAIN, __FILE__, __LINE__, __func__, \
+		__igt_fail_assert(IGT_LOG_DOMAIN, __FILE__, __LINE__, __func__, \
 				  #n1 " " #cmp " " #n2, \
 				  "error: %d " #ncmp " %d\n", __n1, __n2); \
 	} while (0)
@@ -338,7 +344,7 @@ void igt_exit(void) __attribute__((noreturn));
 	do { \
 		uint32_t __n1 = (n1), __n2 = (n2); \
 		if (__n1 cmp __n2) ; else \
-		__igt_fail_assert(99, IGT_LOG_DOMAIN, __FILE__, __LINE__, __func__, \
+		__igt_fail_assert(IGT_LOG_DOMAIN, __FILE__, __LINE__, __func__, \
 				  #n1 " " #cmp " " #n2, \
 				  "error: %#x " #ncmp " %#x\n", __n1, __n2); \
 	} while (0)
diff --git a/lib/intel_batchbuffer.c b/lib/intel_batchbuffer.c
index a1b0643..8b68e52 100644
--- a/lib/intel_batchbuffer.c
+++ b/lib/intel_batchbuffer.c
@@ -377,7 +377,7 @@ intel_blt_copy(struct intel_batchbuffer *batch,
 			    XY_SRC_COPY_BLT_WRITE_RGB;
 		break;
 	default:
-		igt_fail(1);
+		igt_fail(IGT_EXIT_FAILURE);
 	}
 
 	BLIT_COPY_BATCH_START(cmd_bits);
diff --git a/tests/gem_ring_sync_copy.c b/tests/gem_ring_sync_copy.c
index f5ffddc..13af198 100644
--- a/tests/gem_ring_sync_copy.c
+++ b/tests/gem_ring_sync_copy.c
@@ -317,7 +317,7 @@ static void run_test(data_t *data, enum ring r1, enum ring r2, enum test test)
 		bo_check(data, b, 0xc);
 		break;
 	default:
-		igt_fail(1);
+		igt_fail(IGT_EXIT_FAILURE);
 	}
 
 	r1_ops->busy_fini(data);
diff --git a/tests/kms_sink_crc_basic.c b/tests/kms_sink_crc_basic.c
index d2cc7ed..e460404 100644
--- a/tests/kms_sink_crc_basic.c
+++ b/tests/kms_sink_crc_basic.c
@@ -100,7 +100,7 @@ static void assert_color(char *crc, enum color color)
 			   (bh & mask) == 0);
 		break;
 	default:
-		igt_fail(-1);
+		igt_fail(IGT_EXIT_FAILURE);
 	}
 }
 