diff --git a/lib/gpgpu_fill.c b/lib/gpgpu_fill.c
index 4d98643..70d7ea3 100644
--- a/lib/gpgpu_fill.c
+++ b/lib/gpgpu_fill.c
@@ -398,7 +398,7 @@ gen8_emit_state_base_address(struct intel_batchbuffer *batch)
 	OUT_BATCH(1 << 12 | 1);
 	/* indirect object buffer size */
 	OUT_BATCH(0xfffff000 | 1);
-	/* intruction buffer size, must set modify enable bit, otherwise it may result in GPU hang */
+	/* instruction buffer size, must set modify enable bit, otherwise it may result in GPU hang */
 	OUT_BATCH(1 << 12 | 1);
 }
 
@@ -434,7 +434,7 @@ gen9_emit_state_base_address(struct intel_batchbuffer *batch)
 	OUT_BATCH(1 << 12 | 1);
 	/* indirect object buffer size */
 	OUT_BATCH(0xfffff000 | 1);
-	/* intruction buffer size, must set modify enable bit, otherwise it may result in GPU hang */
+	/* instruction buffer size, must set modify enable bit, otherwise it may result in GPU hang */
 	OUT_BATCH(1 << 12 | 1);
 
 	/* Bindless surface state base address */
diff --git a/lib/igt_aux.h b/lib/igt_aux.h
index cdaed29..d4a4c74 100644
--- a/lib/igt_aux.h
+++ b/lib/igt_aux.h
@@ -71,7 +71,7 @@ void igt_cleanup_aperture_trashers(void);
 void igt_system_suspend_autoresume(void);
 void igt_system_hibernate_autoresume(void);
 
-/* dropping priviledges */
+/* dropping privileges */
 void igt_drop_root(void);
 
 void igt_debug_wait_for_keypress(const char *var);
diff --git a/lib/igt_core.c b/lib/igt_core.c
index 832361b..1123633 100644
--- a/lib/igt_core.c
+++ b/lib/igt_core.c
@@ -449,7 +449,7 @@ void __igt_fixture_end(void)
  * running on Android they are sometimes killed by the Android low memory killer.
  * This seems to be due to some incompatibility between the kswapd free memory
  * targets and the way the lowmemorykiller assesses free memory.
- * The low memory killer really isn't usefull in this context and has no
+ * The low memory killer really isn't useful in this context and has no
  * interaction with the gpu driver that we are testing, so the following
  * function is used to disable it by modifying one of its module parameters.
  * We still have the normal linux oom killer to protect the kernel.
@@ -490,7 +490,7 @@ static void low_mem_killer_disable(bool disable)
 		igt_assert(adj_scores_len > 0);
 
 		/* writing 9999 to this module parameter effectively diables the
-		 * low memory killer. This is not a real file, so we dont need to
+		 * low memory killer. This is not a real file, so we don't need to
 		 * seek to the start or truncate it */
 		igt_assert_eq(write(fd, no_lowmem_killer, sizeof(no_lowmem_killer)),
 			      sizeof(no_lowmem_killer));
@@ -1645,7 +1645,7 @@ void igt_install_exit_handler(igt_exit_handler_t fn)
 	igt_assert_f(0, "failed to install the signal handler\n");
 }
 
-/* simulation enviroment support */
+/* simulation environment support */
 
 /**
  * igt_run_in_simulation:
diff --git a/lib/igt_core.h b/lib/igt_core.h
index b3fa735..78dc74f 100644
--- a/lib/igt_core.h
+++ b/lib/igt_core.h
@@ -768,7 +768,7 @@ extern enum igt_log_level igt_log_level;
  */
 #define igt_warn_on(condition) do {\
 		if (condition) \
-			igt_warn("Warning on condition %s in fucntion %s, file %s:%i\n", \
+			igt_warn("Warning on condition %s in function %s, file %s:%i\n", \
 				 #condition, __func__, __FILE__, __LINE__); \
 	} while (0)
 
@@ -790,7 +790,7 @@ extern enum igt_log_level igt_log_level;
  */
 #define igt_warn_on_f(condition, f...) do {\
 		if (condition) {\
-			igt_warn("Warning on condition %s in fucntion %s, file %s:%i\n", \
+			igt_warn("Warning on condition %s in function %s, file %s:%i\n", \
 				 #condition, __func__, __FILE__, __LINE__); \
 			igt_warn(f); \
 		} \
diff --git a/lib/intel_reg.h b/lib/intel_reg.h
index 0ffa803..6104623 100644
--- a/lib/intel_reg.h
+++ b/lib/intel_reg.h
@@ -246,7 +246,7 @@ SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  * not sure they refer to local (graphics) memory.
  *
  * These details are for the local memory control registers,
- * (pp301-310).  The test machines are not equiped with local memory,
+ * (pp301-310).  The test machines are not equipped with local memory,
  * so nothing is tested.  Only a single row seems to be supported.
  */
 #define DRAM_ROW_TYPE      0x3000
diff --git a/lib/ioctl_wrappers.c b/lib/ioctl_wrappers.c
index 076bce8..5ac5701 100644
--- a/lib/ioctl_wrappers.c
+++ b/lib/ioctl_wrappers.c
@@ -385,7 +385,7 @@ void gem_set_domain(int fd, uint32_t handle,
  * @handle: gem buffer object handle
  * @timeout_ns: [in] time to wait, [out] remaining time (in nanoseconds)
  *
- * This functions waits for outstanding rendering to complete, upto
+ * This functions waits for outstanding rendering to complete, up to
  * the timeout_ns. If no timeout_ns is provided, the wait is indefinite and
  * only returns upon an error or when the rendering is complete.
  */
diff --git a/lib/media_fill_gen8.c b/lib/media_fill_gen8.c
index 4a8fe5a..074dbe9 100644
--- a/lib/media_fill_gen8.c
+++ b/lib/media_fill_gen8.c
@@ -223,7 +223,7 @@ gen8_emit_state_base_address(struct intel_batchbuffer *batch)
 	OUT_BATCH(1 << 12 | 1);
 	/* indirect object buffer size */
 	OUT_BATCH(0xfffff000 | 1);
-	/* intruction buffer size, must set modify enable bit, otherwise it may result in GPU hang */
+	/* instruction buffer size, must set modify enable bit, otherwise it may result in GPU hang */
 	OUT_BATCH(1 << 12 | 1);
 }
 
diff --git a/lib/media_fill_gen8lp.c b/lib/media_fill_gen8lp.c
index 1f8a4ad..963f6aa 100644
--- a/lib/media_fill_gen8lp.c
+++ b/lib/media_fill_gen8lp.c
@@ -223,7 +223,7 @@ gen8_emit_state_base_address(struct intel_batchbuffer *batch)
 	OUT_BATCH(1 << 12 | 1);
 	/* indirect object buffer size */
 	OUT_BATCH(0xfffff000 | 1);
-	/* intruction buffer size, must set modify enable bit, otherwise it may result in GPU hang */
+	/* instruction buffer size, must set modify enable bit, otherwise it may result in GPU hang */
 	OUT_BATCH(1 << 12 | 1);
 }
 
diff --git a/lib/media_fill_gen9.c b/lib/media_fill_gen9.c
index 3fd2181..becb3b7 100644
--- a/lib/media_fill_gen9.c
+++ b/lib/media_fill_gen9.c
@@ -223,7 +223,7 @@ gen9_emit_state_base_address(struct intel_batchbuffer *batch)
 	OUT_BATCH(1 << 12 | 1);
 	/* indirect object buffer size */
 	OUT_BATCH(0xfffff000 | 1);
-	/* intruction buffer size, must set modify enable bit, otherwise it may result in GPU hang */
+	/* instruction buffer size, must set modify enable bit, otherwise it may result in GPU hang */
 	OUT_BATCH(1 << 12 | 1);
 
 	/* Bindless surface state base address */
diff --git a/lib/media_spin.c b/lib/media_spin.c
index 580c109..81c71fd 100644
--- a/lib/media_spin.c
+++ b/lib/media_spin.c
@@ -249,7 +249,7 @@ gen8_emit_state_base_address(struct intel_batchbuffer *batch)
 	OUT_BATCH(1 << 12 | 1);
 	/* indirect object buffer size */
 	OUT_BATCH(0xfffff000 | 1);
-	/* intruction buffer size, must set modify enable bit, otherwise it may result in GPU hang */
+	/* instruction buffer size, must set modify enable bit, otherwise it may result in GPU hang */
 	OUT_BATCH(1 << 12 | 1);
 }
 
@@ -285,7 +285,7 @@ gen9_emit_state_base_address(struct intel_batchbuffer *batch)
 	OUT_BATCH(1 << 12 | 1);
 	/* indirect object buffer size */
 	OUT_BATCH(0xfffff000 | 1);
-	/* intruction buffer size, must set modify enable bit, otherwise it may result in GPU hang */
+	/* instruction buffer size, must set modify enable bit, otherwise it may result in GPU hang */
 	OUT_BATCH(1 << 12 | 1);
 
 	/* Bindless surface state base address */
diff --git a/lib/rendercopy_gen8.c b/lib/rendercopy_gen8.c
index a7fc2c4..a8ccddc 100644
--- a/lib/rendercopy_gen8.c
+++ b/lib/rendercopy_gen8.c
@@ -552,7 +552,7 @@ gen8_emit_state_base_address(struct intel_batchbuffer *batch) {
 	OUT_BATCH(1 << 12 | 1);
 	/* indirect object buffer size */
 	OUT_BATCH(0xfffff000 | 1);
-	/* intruction buffer size */
+	/* instruction buffer size */
 	OUT_BATCH(1 << 12 | 1);
 }
 
diff --git a/lib/rendercopy_gen9.c b/lib/rendercopy_gen9.c
index 9537480..aa60494 100644
--- a/lib/rendercopy_gen9.c
+++ b/lib/rendercopy_gen9.c
@@ -513,7 +513,7 @@ static void
 gen9_emit_state_base_address(struct intel_batchbuffer *batch) {
 
 	/* WaBindlessSurfaceStateModifyEnable:skl,bxt */
-	/* The length has to be one less if we dont modify
+	/* The length has to be one less if we don't modify
 	   bindless state */
 	OUT_BATCH(GEN6_STATE_BASE_ADDRESS | (19 - 1 - 2));
 
@@ -544,7 +544,7 @@ gen9_emit_state_base_address(struct intel_batchbuffer *batch) {
 	OUT_BATCH(1 << 12 | 1);
 	/* indirect object buffer size */
 	OUT_BATCH(0xfffff000 | 1);
-	/* intruction buffer size */
+	/* instruction buffer size */
 	OUT_BATCH(1 << 12 | 1);
 
 	/* Bindless surface state base address */
diff --git a/lib/tests/igt_segfault.c b/lib/tests/igt_segfault.c
index d07677d..0fe02c3 100644
--- a/lib/tests/igt_segfault.c
+++ b/lib/tests/igt_segfault.c
@@ -31,7 +31,7 @@
  * 1. Test a crashing simple test is reported.
  * 2. Test a crashing subtest is reported.
  * 3. Test a crashing subtest following a passing subtest is reported.
- * 4. Test a crashing subtest preceeding a passing subtest is reported.
+ * 4. Test a crashing subtest preceding a passing subtest is reported.
  */
 
 #include <signal.h>
@@ -131,7 +131,7 @@ int main(int argc, char **argv)
 	fflush(stdout);
 	internal_assert(do_fork() == SIGSEGV + 128);
 
-	/* Test crash in a subtest preceeding a pass is reported */
+	/* Test crash in a subtest preceding a pass is reported */
 	simple = false;
 	runa=false;
 	runc=true;